package istia.st.avat.server;


import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.View;

@Controller
public class RestMetier {

	// couche métier
	@Autowired
	private IMetier metier;
	@Autowired
	private View view;

	// nombre aléatoire
	@RequestMapping(value = "/random/{a}/{b}", method = RequestMethod.GET)
	public ModelAndView randomNumber(@PathVariable("a") int a,
			@PathVariable("b") int b) {

		// on utilise la couche métier
		int n = 0;
		try {
			n = metier.randomNumber(a, b);
			// suivi
			return new ModelAndView(view, "data", String.valueOf(n));
		} catch (Exception e) {
			// suivi
			return createResponseError("103", e.getMessage());
		}
	}

	// crée une réponse d'erreur
	private ModelAndView createResponseError(String numero, String message) {
		Map<String, Object> modèle = new HashMap<String, Object>();
		modèle.put("error", numero);
		modèle.put("message", message);
		return new ModelAndView(view, modèle);
	}
}
