package istia.st.avat.exemples.vues;

import istia.st.avat.android.Vue;
import istia.st.avat.core.ISession;
import istia.st.avat.exemples.R;
import istia.st.avat.exemples.activity.Factory;
import istia.st.avat.exemples.activity.MainActivity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

public class Vue_02 extends Vue {

	// les éléments de l'interface visuelle
	private Button btnRetour;
	private TextView edtNbAleas;
	private TextView edtA;
	private TextView edtB;
	private TextView edtUrlServiceRest;
	private TextView edtSleepTime;

	// les saisies
	private int nbAleas;
	private int a;
	private int b;
	private String urlServiceRest;
	private int sleepTime;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		// on crée la vue du fragment à partir de sa définition XML
		return inflater.inflate(R.layout.vue_02, container, false);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// parent
		super.onActivityCreated(savedInstanceState);

		// zones d'affichage
		edtUrlServiceRest = (TextView) activity.findViewById(R.id.edt_urlServiceRest);
		edtNbAleas = (TextView) activity.findViewById(R.id.edt_nbaleas);
		edtA = (TextView) activity.findViewById(R.id.edt_a);
		edtB = (TextView) activity.findViewById(R.id.edt_b);
		edtSleepTime = (TextView) activity.findViewById(R.id.edt_sleepTime);

		// bouton Retour
		btnRetour = (Button) activity.findViewById(R.id.btn_Retour);
		btnRetour.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				doRetour();
			}
		});

	}

	@Override
	public void onResume() {
		// parent d'abord
		super.onResume();
		// on récupère les résultats dans la session (urlServiceRest, nbAleas, a, b,
		// sleepTime)
		ISession session = (ISession) factory.getObject(Factory.SESSION, (Object[]) null);
		urlServiceRest = (String) session.get("urlServiceRest");
		nbAleas = (Integer) session.get("nbAleas");
		a = (Integer) session.get("a");
		b = (Integer) session.get("b");
		sleepTime = (Integer) session.get("sleepTime");
		// on met à jour la page avec ces éléments
		edtUrlServiceRest.setText(urlServiceRest);
		edtNbAleas.setText(String.valueOf(nbAleas));
		edtA.setText(String.valueOf(a));
		edtB.setText(String.valueOf(b));
		edtSleepTime.setText(String.valueOf(sleepTime));
	}

	protected void doRetour() {
		// on affiche la vue 1
		((MainActivity) activity).showVue(1);
	}

	@Override
	public void notifyEndOfTasks() {
	}

}
