package istia.st.avat.exemples.activity;

import istia.st.avat.android.Vue;
import istia.st.avat.exemples.R;
import istia.st.avat.exemples.vues.Vue_01;
import istia.st.avat.exemples.vues.Vue_02;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Window;

public class MainActivity extends FragmentActivity {

	// la factory
	private Factory factory;
	// les vues
	private Vue[] vues;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// le sablier
		requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
		setProgressBarIndeterminateVisibility(false);
		// template qui accueille les vues
		setContentView(R.layout.main);
		// la factory
		factory = new Factory(this, new Config());
		// on définit les deux vues
		Vue_01 vue_01 = (Vue_01) factory.getObject(Factory.VUE_01, null, "Vue_01");
		Vue_02 vue_02 = (Vue_02) factory.getObject(Factory.VUE_02, null, "Vue_02");
		// on stocke leurs références dans un tableau
		vues = new Vue[] { vue_01, vue_02 };
		// on fait de vue_01 la vue courante
		showVue(1);
	}

	// affichage d'une vue
	public void showVue(int i) {
		// i=1 --> vue_01, i=2 --> vue_02
		// affichage vue
		FragmentTransaction fragmentTransaction = getFragmentManager().beginTransaction();
		fragmentTransaction.replace(R.id.container, vues[i - 1]);
		fragmentTransaction.commit();
	}

}
