package istia.st.avat.exemples.vues;

import istia.st.avat.android.Vue;
import istia.st.avat.core.IBoss;
import istia.st.avat.core.IWorker;
import istia.st.avat.exemples.R;
import istia.st.avat.exemples.activity.MainActivity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class Vue_02 extends Vue {

	// les éléments de l'interface visuelle
	private Button btnRetour;
	private TextView edtNbAleas;
	private TextView edtA;
	private TextView edtB;
	private TextView edtUrlServiceRest;
	private TextView edtSleepTime;

	// le modèle de la vue
	private String urlServiceRest;
	private Integer nbAleas;
	private Integer a;
	private Integer b;
	private Integer sleepTime;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		// on crée la vue du fragment à partir de sa définition XML
		return inflater.inflate(R.layout.vue_02, container, false);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// parent
		super.onActivityCreated(savedInstanceState);

		// zones d'affichage
		edtUrlServiceRest = (TextView) activity.findViewById(R.id.edt_urlServiceRest);
		edtNbAleas = (TextView) activity.findViewById(R.id.edt_nbaleas);
		edtA = (TextView) activity.findViewById(R.id.edt_a);
		edtB = (TextView) activity.findViewById(R.id.edt_b);
		edtSleepTime = (TextView) activity.findViewById(R.id.edt_sleepTime);

		// bouton Retour
		btnRetour = (Button) activity.findViewById(R.id.btn_Retour);
		btnRetour.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				doRetour();
			}
		});

	}

	protected void doRetour() {
		// on affiche la vue 1
		((MainActivity) activity).showVue(1);
	}

	@Override
	public void onResume(){
		// parent
		super.onResume();
		// on affiche les résultats mémorisés
		edtUrlServiceRest.setText(urlServiceRest);
		edtNbAleas.setText(String.valueOf(nbAleas));
		edtA.setText(String.valueOf(a));
		edtB.setText(String.valueOf(b));
		edtSleepTime.setText(String.valueOf(sleepTime));		
	}
	
	@Override
	public void notifyEndOfTasks() {
		Toast.makeText(activity, "Action terminée", Toast.LENGTH_SHORT).show();
	}

	@Override
	public void notifyEvent(IWorker worker, int eventType, Object event) {
		// parent
		super.notifyEvent(worker, eventType, event);
		// on gère l'évt WORK_TERMINATED
		if (eventType == IBoss.WORK_TERMINATED) {
			// on mémorise les éléments reçus
			Object[] results = (Object[]) event;
			urlServiceRest = (String) results[0];
			nbAleas = (Integer) results[1];
			a = (Integer) results[2];
			b = (Integer) results[3];
			sleepTime = (Integer) results[4];
		}
	}

}
