package android.rdvmedecins.metier;

import java.util.List;

import android.rdvmedecins.dao.IDao;
import android.rdvmedecins.entities.dao.Client;
import android.rdvmedecins.entities.dao.Creneau;
import android.rdvmedecins.entities.dao.Medecin;
import android.rdvmedecins.entities.dao.Rv;
import android.rdvmedecins.entities.metier.AgendaMedecinJour;

public interface IMetier {

	// @RequestMapping(value = "/getAllClients", method = RequestMethod.GET)
	public abstract List<Client> getAllClients();

	// @RequestMapping(value = "/getAllMedecins", method = RequestMethod.GET)
	public abstract List<Medecin> getAllMedecins();

	// @RequestMapping(value = "/getAllCreneaux/{idMedecin}", method =
	// RequestMethod.GET)
	public abstract List<Creneau> getAllCreneaux(Long idMedecin);

	// @RequestMapping(value = "/getRvMedecinJour/{idMedecin}/{jour}", method =
	// RequestMethod.GET)
	public abstract List<Rv> getRvMedecinJour(Long idMedecin, String jour);

	//@RequestMapping(value = "/getClientById/{idClient}", method = RequestMethod.GET)
	public abstract Client getClientById(Long idClient);

	//@RequestMapping(value = "/getMedecinById/{idMedecin}", method = RequestMethod.GET)
	public abstract Medecin getMedecinById(Long idMedecin);

	//@RequestMapping(value = "/getRvById/{idRv}", method = RequestMethod.GET)
	public abstract Rv getRvById(Long idRv);

	//@RequestMapping(value = "/getCreneauById/{idCreneau}", method = RequestMethod.GET)
	public abstract Creneau getCreneauById(Long idCreneau);

	//@RequestMapping(value = "/ajouterRv/{jour}/{idCreneau}/{idClient}", method = RequestMethod.GET)
	public abstract Rv ajouterRv(String jour, Long idCreneau, Long idClient);

	//@RequestMapping(value = "/supprimerRv/{idRv}", method = RequestMethod.GET)
	public abstract void supprimerRv(Long idRv);

	//@RequestMapping(value = "/getAgendaMedecinJour/{idMedecin}/{jour}", method = RequestMethod.GET)
	public abstract AgendaMedecinJour getAgendaMedecinJour(Long idMedecin, String jour);

	// setters
	public abstract void setDao(IDao dao);

	public abstract void setUrlServiceRest(String urlServiceRest);

}