package android.rdvmedecins.ui.activity;

import istia.st.avat.android.Vue;
import android.rdvmedecins.ui.R;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Window;

public class MainActivity extends FragmentActivity {

	// la factory
	private Factory factory;
	// les vues
	private Vue configVue;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// le sablier
		requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
		setProgressBarIndeterminateVisibility(false);
		// template qui accueille les vues
		setContentView(R.layout.main);
		// la factory
		factory = new Factory(this, new Config());
		// on définit la première vue
		configVue = (Vue) factory.getObject(Factory.CONFIG_VUE, null, "ConfigVue");
		// on fait de configVue la vue courante
		showVue(configVue);
	}

	// affichage d'une vue
	public void showVue(Vue vue) {
		// affichage vue
		FragmentTransaction fragmentTransaction = getFragmentManager().beginTransaction();
		fragmentTransaction.replace(R.id.container, vue);
		fragmentTransaction.commit();
	}

}
