package android.rdvmedecins.ui.tasks;

import istia.st.avat.android.Task;
import istia.st.avat.core.IBoss;
import android.rdvmedecins.entities.dao.Rv;
import android.rdvmedecins.metier.IMetier;
import android.rdvmedecins.ui.activity.Factory;

public class AjouterRvTask extends Task {

	// résultat de la tâche
	private Object info;

	@Override
	// traitement début de tâche dans le thread de l'UI
	protected void onPreExecute() {
		// on passe la tâche à l'état démarré
		boss.notifyEvent(this, IBoss.WORK_STARTED, null);
	}

	@Override
	// on exécute la tâche (jour, idCreneau, idClient)
	protected Void doInBackground(Object... params) {
		// on récupère les paramètres
		String jour = (String) params[0];
		Long idCreneau = (Long) params[1];
		Long idClient = (Long) params[2];
		// on demande une référence sur la couche [métier]
		IMetier metier = (IMetier) factory.getObject(Factory.METIER, (Object[]) null);
		try {
			// on ajoute le RV
			Rv rv = metier.ajouterRv(jour, idCreneau, idClient);
			// on mémorise l'info
			info = rv;
		} catch (Exception ex) {
			// on mémorise l'exception
			info = ex;
		}
		// fin
		return null;
	}

	@Override
	// traitement fin de tâche dans le thread de l'UI
	protected void onPostExecute(Void result) {
		// on a terminé le travail
		boss.notifyEvent(this, IBoss.WORK_INFO, info);
		boss.notifyEvent(this, IBoss.WORK_TERMINATED, null);
	}

}
