package android.rdvmedecins.ui.tasks;

import istia.st.avat.android.Task;
import istia.st.avat.core.IBoss;
import android.rdvmedecins.entities.metier.AgendaMedecinJour;
import android.rdvmedecins.metier.IMetier;
import android.rdvmedecins.ui.activity.Factory;

public class GetAgendaMedecinTask extends Task {

	// résultat de la tâche
	private Object info;

	@Override
	// traitement début de tâche dans le thread de l'UI
	protected void onPreExecute() {
		// on passe la tâche à l'état démarré
		boss.notifyEvent(this, IBoss.WORK_STARTED, null);
	}

	@Override
	// on exécute la tâche (idMedecin, jourRv)	
	protected Void doInBackground(Object... params) {
		// on demande une référence sur la couche [métier]
		IMetier metier = (IMetier) factory.getObject(Factory.METIER, (Object[])null);
		try {
			// on demande l'agenda du médecin pour le jour indiqué
			Long idMedecin = (Long) params[0];
			String jourRv = (String) params[1];
			AgendaMedecinJour agenda = metier.getAgendaMedecinJour(idMedecin, jourRv);
			// on mémorise l'agenda
			info = agenda;
		} catch (Exception ex) {
			// on mémorise l'exception
			info = ex;
		}
		// fin
		return null;
	}

	@Override
	// traitement fin de tâche dans le thread de l'UI
	protected void onPostExecute(Void result) {
		// on a terminé le travail
		boss.notifyEvent(this, IBoss.WORK_INFO, info);
		boss.notifyEvent(this, IBoss.WORK_TERMINATED, null);
	}

}
