package android.rdvmedecins.ui.tasks;

import istia.st.avat.android.Task;
import istia.st.avat.core.IBoss;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.rdvmedecins.entities.dao.Client;
import android.rdvmedecins.metier.IMetier;
import android.rdvmedecins.ui.activity.Factory;

public class GetAllClientsTask extends Task {

	// résultat de la tâche
	private Object info;

	@Override
	// traitement début de tâche dans le thread de l'UI
	protected void onPreExecute() {
		// on passe la tâche à l'état démarré
		boss.notifyEvent(this, IBoss.WORK_STARTED, null);
	}

	@Override
	protected Void doInBackground(Object... params) {
		// on demande une référence sur la couche [métier]
		IMetier metier = (IMetier) factory.getObject(Factory.METIER, params[0]);
		try {
			// on demande la liste des clients à la couche métier
			List<Client> clients = metier.getAllClients();
			// on la met dans un dictionnaire
			Map<String,Object> result=new HashMap<String,Object>();
			result.put("clients",clients);
			info=result;
		} catch (Exception ex) {
			// on note l'exception
			info = ex;
		}
		// fin
		return null;
	}

	@Override
	// traitement fin de tâche dans le thread de l'UI
	protected void onPostExecute(Void result) {
		// on a terminé le travail
		boss.notifyEvent(this, IBoss.WORK_INFO, info);
		boss.notifyEvent(this, IBoss.WORK_TERMINATED, null);
	}

}
