package istia.st.avat.client;

import istia.st.avat.client.dao.ClientException;
import istia.st.avat.client.dao.IDao;

import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;

public class Metier implements IMetier {

	// couche [dao]
	private IDao dao;
	// mapper JSON
	private Gson gson = new Gson();

	// génération d'un nombre aléatoire
	public int randomNumber(String urlServiceRest, int a, int b) {
		// adresse du service REST
		String urlService = String.format("http://%s/random/{a}/{b}", urlServiceRest);
		// paramètres service REST
		Map<String, String> paramètres = new HashMap<String, String>();
		paramètres.put("a", String.valueOf(a));
		paramètres.put("b", String.valueOf(b));
		// exécution service
		String réponse = dao.executeRestService("get", urlService, null, paramètres);
		// exploitation réponse
		try {
			return Integer.parseInt(gson.fromJson(réponse, String.class));
		} catch (Exception ex) {
			throw new ClientException(String.format("Réponse incorrecte du serveur: %s", réponse), ex);
		}
	}
	// setters

	public void setDao(IDao dao) {
		this.dao = dao;
	}
	
}
